Package org.apache.tomcat.util.digester

# Class SetNextRule

java.lang.Object
org.apache.tomcat.util.digester.Rule
org.apache.tomcat.util.digester.SetNextRule

public class SetNextRule extends Rule

Rule implementation that calls a method on the (top-1) (parent) object, passing the top object (child) as an argument. It is commonly used to establish parent-child relationships.

This rule now supports more flexible method matching by default. It is possible that this may break (some) code written against release 1.1.1 or earlier. See `isExactMatch()` for more details.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected String`
`methodName`
The method name to call on the parent object.
`protected String`
`paramType`
The Java class name of the parameter type expected by the method.
`protected boolean`
`useExactMatch`
Should we use exact matching.

### Fields inherited from class org.apache.tomcat.util.digester.Rule

`digester, namespaceURI`

## Constructor Summary

Constructors
Constructor
Description
`SetNextRule(String methodName, String paramType)`
Construct a "set next" rule with the specified method name.

## Method Summary

Modifier and Type
Method
Description
`void`
`end(String namespace, String name)`
Process the end of this element.
`boolean`
`isExactMatch()`
Is exact matching being used.
`void`
`setExactMatch(boolean useExactMatch)`
Set whether exact matching is enabled.
`String`
`toString()`
Render a printable version of this Rule.

### Methods inherited from class org.apache.tomcat.util.digester.Rule

`begin, body, finish, getDigester, getNamespaceURI, setDigester, setNamespaceURI`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### methodName

protected String methodName
The method name to call on the parent object.

### paramType

protected String paramType
The Java class name of the parameter type expected by the method.

### useExactMatch

protected boolean useExactMatch
Should we use exact matching. Default is no.

## Constructor Details

### SetNextRule

public SetNextRule(String methodName, String paramType)
Construct a "set next" rule with the specified method name.

Parameters:
  `methodName` - Method name of the parent method to call
  `paramType` - Java class of the parent method's argument (if you wish to use a primitive type, specify the corresponding Java wrapper class instead, such as `java.lang.Boolean` for a `boolean` parameter)

## Method Details

### isExactMatch

public boolean isExactMatch()

Is exact matching being used.

This rule uses `org.apache.commons.beanutils.MethodUtils` to introspect the relevant objects so that the right method can be called. Originally, `MethodUtils.invokeExactMethod` was used. This matches methods very strictly and so may not find a matching method when one exists. This is still the behaviour when exact matching is enabled.

When exact matching is disabled, `MethodUtils.invokeMethod` is used. This method finds more methods but is less precise when there are several methods with correct signatures. So, if you want to choose an exact signature you might need to enable this property.

The default setting is to disable exact matches.

Returns:
  true iff exact matching is enabled
Since:
  Digester Release 1.1.1

### setExactMatch

public void setExactMatch(boolean useExactMatch)

Set whether exact matching is enabled.

See `isExactMatch()`.

Parameters:
  `useExactMatch` - should this rule use exact method matching
Since:
  Digester Release 1.1.1

### end

public void end(String namespace, String name) throws Exception
Process the end of this element.

Overrides:
  `end` in class `Rule`
Parameters:
  `namespace` - the namespace URI of the matching element, or an empty string if the parser is not namespace aware or the element has no namespace
  `name` - the local name if the parser is namespace aware, or just the element name otherwise
Throws:
  `Exception` - if an error occurs while processing the event

### toString

public String toString()
Render a printable version of this Rule.

Overrides:
  `toString` in class `Object`